<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page isELIgnored ="false" %> 


<%@ taglib uri="http://alarmpoint.com/alarmpoint/4.0#integrationservices" prefix="apia" %>
<%@ taglib uri="http://alarmpoint.com/alarmpoint/4.0#subscription" prefix="subs" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %> 

<jsp:useBean id="subscriptionBean"
             class="com.invoqsystems.apex.web.cocoon.jsp.SubscriptionBeanImpl"
             scope="session" />

<jsp:useBean id="integrationAgentService"
             class="com.alarmpoint.integration.infrastructure.agent.service.IntegrationAgentService"
             scope="session" />



<subscription-panel xmlns:fi="http://apache.org/cocoon/forms/1.0#instance"
                    xmlns:i18n="http://apache.org/cocoon/i18n/2.1"
                    onload="onLoad();"
                    onsubmit="return validateForm(this);" >

    <%@ include file="SubscriptionCssInc.jsp" %>
    <%@ include file="SubscriptionJsInc.jsp" %>

    <input type="hidden" name="currentTab" value="${param.currentTab}" />  

    <text-widget id="name">
      <value><c:out value="${subscriptionBean.name}"/></value>
    </text-widget>

    <group label="Attributes">

      <tab-group id="attributes">
      
        <subs:panel tabLabel="Alarm Information" tabCount="4" subscriptionId="${param.subscriptionId}">
          <subs:predicate name="MNAME" label="Model Name" tabPosition="1" performSearch="true" 
                          url="/jsp/subscription/caspectrum/SpectrumSubscriptionSubSearch.jsp" queryParameters="name=MNAME|desc=Model Name|key=name|value=name|cli_action=show models|cli_type=com.alarmpoint.spectrum.data.SpectrumModel|doNotRun=true"/>
          <subs:predicate name="MTYPE" label="Model Type Name" tabPosition="1" performSearch="true" 
                          url="/jsp/subscription/caspectrum/SpectrumSubscriptionSubSearch.jsp" queryParameters="name=MTYPENAME|desc=Model Type Name|key=name|value=name|cli_action=show types|cli_type=com.alarmpoint.spectrum.data.SpectrumType|doNotRun=true"/>
          <subs:predicate name="SEV" label="Severity" tabPosition="1"/>
          <subs:predicate name="DTYPE" label="Device Type" tabPosition="1"/>
          <subs:predicate name="IPADDRESS" label="Network Address" tabPosition="1"/>
          <subs:predicate name="PCAUSE" label="Probable Cause" tabPosition="1"/>
          <subs:predicate name="ALARMTITLE" label="Alarm Title" tabPosition="1"/>
        </subs:panel>

      </tab-group>

    </group>

</subscription-panel>
