<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page isELIgnored ="false" %> 


<%@ taglib uri="http://alarmpoint.com/alarmpoint/4.0#integrationservices" prefix="apia" %>
<%@ taglib uri="http://alarmpoint.com/alarmpoint/4.0#subscription" prefix="subs" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %> 
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %> 

<jsp:useBean id="subscriptionBean"
             class="com.invoqsystems.apex.web.cocoon.jsp.SubscriptionBeanImpl"
             scope="session" />

<jsp:useBean id="integrationAgentService"
             class="com.alarmpoint.integration.infrastructure.agent.service.IntegrationAgentService"
             scope="session" />

<page>
  <window-popup onload="updateFromParent('${param.filterOperator}', '${param.predicateId}', 'items', 'parent.items');">

    <%@ include file="SubscriptionJsInc.jsp" %>
    <script type="text/javascript" language="JavaScript">
      window.name="SubscriptionSubSearch"
    </script>
    
    <!-- The form-action URL will need to be modified for the specific integration. Note this is called on a postback, so it will
         most likely use request parameters to populate the query string. -->
    <form name="POPUP_FORM"
          method="POST" 
          action="${pageContext.request.servletPath}/jsp/subscription/caspectrum/SpectrumSubscriptionSubSearch.jsp;jsessionid=${pageContext.session.id}?name=${param.name}&amp;desc=${param.desc}&amp;key=${param.key}&amp;value=${param.value}&amp;cli_action=${param.cli_action}&amp;cli_type=${param.cli_type}&amp;doNotRun=false&amp;predicateId=${param.predicateId}"
          onsubmit="selectAllTargetOptions(this, 'items');"
          target="SubscriptionSubSearch">
          
      <!-- Remove the %20 encoding from the description and command-->                   
      <c:set var="ref">${param.desc}</c:set>  
      <c:set var="desc" value='${fn:replace(ref,"%20"," ")}'/>                 

      <c:set var="cmd">${param.cli_action}</c:set>  
      <c:set var="cli_action" value='${fn:replace(cmd,"%20"," ")}'/>                 
      
      <group label="Search ${desc}">
        <div class="no-list-table-data-title">
          <caption>
            <span style="white-space:normal;">To find a list of available ${desc}s, specify your search criteria, and then click "Get ${desc}."</span>
          </caption>
        </div>
      
        <div class="form-group">
          <table>
          
            <tr>
              <th>Name</th><th>Operator</th><th>Value</th>
            </tr>

            <!-- This row is specific for the SPECTRUM integration -->
            <tr>
              <td>Landscape Handle</td>
              <td type="template">MATCHES</td>
              <td type="template">
                <select id="landscapeHandle" name="landscapeHandle">
                    <option value=""/>
                    <apia:option id="${param.predicateId}" action="show" service="caspectrum" domain="caspectrum" company="Default Company" keyField="handle" valueField="handle" selectedValue="${param.landscapeHandle}" sorted="true">
                      <apia:argument name="cli_action" type="string">show landscapes</apia:argument>
                      <apia:argument name="cli_type" type="string">com.alarmpoint.spectrum.data.SpectrumLandscape</apia:argument>
                    </apia:option>
                </select>
              </td>
            </tr>
            
            <!-- This is the default search criteria box using the information passed into the page. This should not need to be modified -->
            <tr>
              <td>${desc}</td>
              <td type="template">
                <select id="filterOperator" name="filterOperator">
                  <option value="CONTAINS" <c:if test='${param.filterOperator == "CONTAINS"}'>selected="selected"</c:if> >CONTAINS</option>
                  <option value="ENDS WITH" <c:if test='${param.filterOperator == "ENDS WITH"}'>selected="selected"</c:if> >ENDS WITH</option>
                  <option value="STARTS WITH" <c:if test='${param.filterOperator == "STARTS WITH"}'>selected="selected"</c:if> >STARTS WITH</option>
                  <option value="MATCHES" <c:if test='${param.filterOperator == "MATCHES"}'>selected="selected"</c:if> >MATCHES</option>
                </select>
              </td>
              <td type="template">
                <input id="filterValue" name="filterValue" value="<c:out value='${param.filterValue}'/>"/>
              </td>
            </tr>
          </table>
        </div>
        <action-button id="refreshButton" label="Get ${desc}" onclick="doPrePostActions('items');" />
      </group>
      
      <div class="form-group">
        <div class="double-list-widget">
          <label>Available ${desc}s:</label>
          <br clear="all"/>
          <select style="width:300px;" multiple="0" name="items.unselected" id="items.unselected" size="9" ondblclick="add('items', 'items.unselected'); return false;">
          
            <!-- This is the call that will retrieve the data from the management system using the integration agent. Modify the attributes as required -->
            <apia:option id="${param.predicateId}" action="show" service="caspectrum" domain="caspectrum" company="Default Company" keyField="${param.key}" valueField="${param.value}" 
                         filterOperator="${param.filterOperator}" filterValue="${param.filterValue}" sorted="true" doNotRun="${param.doNotRun}">
              <apia:argument name="cli_action" type="string">${cli_action} <c:if test="${param.landscapeHandle != ''}">lh=${param.landscapeHandle}</c:if></apia:argument>
              <apia:argument name="cli_type" type="string">${param.cli_type}</apia:argument>
            </apia:option>
            
          </select>
        </div>
        
        
        <!-- This is boilerplate HTML and shouldn't need to be amended. It manages the Add/Remove buttons, shows the
             selected items and the Save/Close buttons-->
        <div class="double-list-button-cluster">
          <div class="float-none">
            <span id="addButton">
              <input id="addButton:input" class="double-list-action" name="addButton" type="button"
                     onclick="add('items', 'items.unselected'); return false;" value="Add &gt;"/>
            </span>
            <br/>
            <span id="removeButton">
              <input id="removeButton:input" class="double-list-action" name="removeButton" type="button"
                     onclick="remove('items', 'items.unselected'); return false;" value="&lt; Remove"/>
            </span>
          </div>
        </div>        

        <div class="double-list-widget">
          <label>Selected ${desc}s:</label>
          <br clear="all"/>
          <select style="width:300px;" multiple="0" name="items" id="items" size="9" ondblclick="remove('items', 'items.unselected'); return false;">
            <c:forEach items="${paramValues.items}" var="currentItem">
              <option value="<c:out value='${currentItem}'/>"><c:out value="${currentItem}"/></option>
            </c:forEach>
          </select>
          <select style="display:none" multiple="0" name="parent.items" id="parent.items" size="9">
            <c:forEach items="${paramValues.items}" var="currentItem">
              <option value="<c:out value='${currentItem}'/>"><c:out value="${currentItem}"/></option>
            </c:forEach>
          </select>
        </div>
      </div>
      <input id="saveButton:input" class="double-list-action" name="saveButton" type="button" onclick="return updateParentForm(this.form, 'items', '${param.predicateId}');" value="Save"/>
      <input id="cancelButton:input" class="double-list-action" name="cancelButton" type="button" onclick="return updateParentForm(this.form, 'parent.items', '${param.predicateId}');" value="Cancel"/>
    </form>                   
  </window-popup>
</page>
