<script type="text/javascript" language="JavaScript">
  //============================================================================
  // Global Javascript file used by subscription panels
  //============================================================================

  var old_forms_showTab;

  /**
   * Called on loading the form
   */
  function onLoad()
  {
    old_forms_showTab = forms_showTab;
    forms_showTab = new_forms_showTab;
    var lastTab = document.DefaultSubscriptionForm.currentTab.value;
    if(lastTab != null &amp;&amp; lastTab != "" &amp;&amp; lastTab != "null")
    {
      forms_showTab("attributes", lastTab, 5, "");
    }
  }
  
  /**
   * Show the tab when clicked
   */
  function new_forms_showTab(tabgroup, idx, length, state)
  {
    document.DefaultSubscriptionForm.currentTab.value = idx;
    old_forms_showTab(tabgroup, idx, length, state);
  }

  /**
   * form validation to ensure that all required predicates are supplied
   */
  function validateForm(theForm)
  {
    if(selectedButtonId == "saveButton:input")
    {
      if (isBlank(theForm['name'].value))
      {
        alert('The Name ' + MSG_CustomRequiredField);
        theForm['name'].focus();
        selectedButtonId = "";
        return false;
      }
    }
    disableFormButtons(theForm);
    addFormField(theForm, 'hidden', selectedButtonId, requestedFormAction);
    return true;
  }

  /**
   * This is called by submitCloseChildSubmitParent
   */
  function submitRefresh()
  {
    disableFormButtons(document.forms['DefaultSubscriptionForm']);
    addFormField(document.forms['DefaultSubscriptionForm'], 'hidden', 'refreshButton', 'refreshButton');
    setTimeout("document.forms['DefaultSubscriptionForm'].submit()", 500);
  }

  /**
   * Sorts the list predicates
   */
  function sortListPredicates(theForm)
  {
    for (var i = 0; i &lt; theForm.elements.length; i++)
    {
      if (theForm.elements[i].type == "select-multiple")
      {
        if ((theForm.elements[i].name).substr(0, 16) == "PREDICATE_VALUE_")
        {
          sortSelect(theForm.elements[i]);
        }
      }
    }
  }


  //============================================================================
  // Javascript calls to support the sub-search functionality
  //============================================================================

  /**
   * Loads the search form for the given predicate
   */
  function search(url, predicateId, select)
  {
    if ( !window.focus ) return true;
    windowPopup(url + "&amp;predicateId=" + predicateId , name, '800','600','center','front');
    return false;
  }

  /**
   * Remove duplicate items in a search box
   */
  function removeDuplicates( listBox )
  {
    var lastItemValue = "";
    for( var i=(listBox.options.length-1); i >=0; i-- )
    {
      var item = listBox.options[i];
      if( lastItemValue == item.value )
      {
        listBox.options[i] = null;
      }
      lastItemValue = item.value; 
    }
  }

  /**
   * Performs a select all function in the select box
   */
  function setAllSelected( selectBox )
  {
    for ( var i = 0; i &lt; selectBox.options.length; i++ )
    {
      selectBox.options[i].selected = true;
    }
  }

  /**
   * Select all items in the items select prior to posting the form
   */
  function doPrePostActions(targetId)
  {
    setAllSelected(document.getElementById(targetId));
  }

  /**
   * Copies the source to the target
   */
  function setSelectionOptions(source, target)
  {
    // clear the left list
    removeAllOptions(target);
    // copy from source to left list
    copySelectedOptions(source, target);
  }

  /**
   * Removes all the options from the select box
   */
  function removeAllOptions(from)
  {
    for (var i=(from.options.length-1); i>=0; i--)
    {
      from.options[i] = null;
    }
    from.selectedIndex = -1;
  }

  /**
   * Adds the selected item to the target
   */
  function add(selected, unselected)
  {
    selectedItems = document.getElementById(selected);
    unselectedItems = document.getElementById(unselected);
    moveSelectedOptions( unselectedItems, selectedItems );
    removeDuplicates( selectedItems );
    removeDuplicates( unselectedItems );
  }
  
  /**
   * Remove the selected item from the target
   */
  function remove(selected, unselected)
  {
    selectedItems = document.getElementById(selected);
    unselectedItems = document.getElementById(unselected);
    moveSelectedOptions( selectedItems, unselectedItems );
    removeDuplicates( selectedItems );
    removeDuplicates( unselectedItems );
  }
  
  /**
   * Updates the select box in the parent with the selected values
   */
  function updateFromParent(postback, selectId, targetId, parentItemsId)
  {
    if (postback == null || postback == '')
    {
      // Update the currently selected items and the hidden original parent items for the cancel operation
      var select = self.opener.document.getElementById(selectId);
      updateTargetSelect(select, targetId);
      updateTargetSelect(select, parentItemsId);
    }
  }
  
  /**
   * Updates the target select from the source select
   */
  function updateTargetSelect(source, targetId)
  {
      var selectedItemList = document.getElementById(targetId);
      removeAllOptions(selectedItemList);
      if (source.options.length != 0)
      {
        copyAllOptions(source, selectedItemList);
      }
  }
  
  /**
   * Update the parent form from the child form
   */
  function updateParentForm(childForm, sourceId, targetId)
  {
    selectAllTargetOptions( childForm, sourceId );
    var source = childForm[sourceId];
    self.opener.updateSelectedValues(source, targetId);
    self.close();
    return false;
  }
  
  /**
   * Update the targeted select with the values from the source
   */
  function updateSelectedValues(source, targetId)
  {
    var target = document.getElementById(targetId);
    setSelectionOptions(source, target);
    setAllSelected(target);
  }

</script>
